package kaysaar.aotd_question_of_loyalty.data.plugins;

import java.lang.reflect.Method;
import java.lang.reflect.Field;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.campaign.CampaignUIAPI;
import com.fs.starfarer.api.campaign.CoreUIAPI;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.ui.UIPanelAPI;

public class ProductionUtil
{
    public static UIPanelAPI getCoreUI() {
        final CampaignUIAPI campaignUI = Global.getSector().getCampaignUI();
        final InteractionDialogAPI dialog = campaignUI.getCurrentInteractionDialog();
        CoreUIAPI core;
        if (dialog == null) {
            core = (CoreUIAPI)ReflectionUtilis.invokeMethod("getCore", campaignUI, new Object[0]);
        }
        else {
            core = (CoreUIAPI)ReflectionUtilis.invokeMethod("getCoreUI", dialog, new Object[0]);
        }
        return (core == null) ? null : ((UIPanelAPI)core);
    }
    
    public static UIPanelAPI getCurrentTab() {
        final UIPanelAPI coreUltimate = getCoreUI();
        final UIPanelAPI core = (UIPanelAPI)ReflectionUtilis.invokeMethod("getCurrentTab", coreUltimate, new Object[0]);
        return (core == null) ? null : core;
    }
    
    public static Object getField(final Object o, final String fieldName) {
        return getFieldExplicitClass(o.getClass(), o, fieldName);
    }
    
    public static Object getFieldExplicitClass(final Class<?> cls, final Object o, final String fieldName) {
        if (o == null) {
            return null;
        }
        try {
            final Field field = cls.getDeclaredField(fieldName);
            field.setAccessible(true);
            return field.get(o);
        }
        catch (final Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static void setField(final Object o, final String fieldName, final Object to) {
        setFieldExplicitClass(o.getClass(), o, fieldName, to);
    }
    
    public static void setFieldExplicitClass(final Class<?> cls, final Object o, final String fieldName, final Object to) {
        if (o == null) {
            return;
        }
        try {
            final Field field = cls.getDeclaredField(fieldName);
            field.setAccessible(true);
            field.set(o, to);
        }
        catch (final Exception e) {
            e.printStackTrace();
        }
    }
    
    public static Object invokeGetter(final Object o, final String methodName, final Object... args) {
        if (o == null) {
            return null;
        }
        try {
            final Class<?>[] argClasses = new Class[args.length];
            for (int i = 0; i < args.length; ++i) {
                argClasses[i] = args[i].getClass();
                if (argClasses[i] == Integer.class) {
                    argClasses[i] = Integer.TYPE;
                }
                else if (argClasses[i] == Boolean.class) {
                    argClasses[i] = Boolean.TYPE;
                }
                else if (argClasses[i] == Float.class) {
                    argClasses[i] = Float.TYPE;
                }
            }
            final Method method = o.getClass().getMethod(methodName, argClasses);
            return method.invoke(o, args);
        }
        catch (final Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
